--- asterisk-orig/pbx.c	2006-05-16 09:49:46.690680105 +0200
+++ asterisk/pbx.c	2006-05-16 10:15:05.640841538 +0200
@@ -343,7 +343,8 @@
 
 	{ "Hangup", pbx_builtin_hangup,
 	"Hang up the calling channel",
-	"  Hangup(): This application will hang up the calling channel.\n"
+	"  Hangup([causecode]): This application will hang up the calling channel.\n"
+	"If an option is given, HANGUPCAUSE will be set to the given numeric value.\n"
 	},
 
 	{ "NoOp", pbx_builtin_noop,
@@ -5011,8 +5012,11 @@
 static int pbx_builtin_hangup(struct ast_channel *chan, void *data)
 {
 	/* Just return non-zero and it will hang up */
-	if (!chan->hangupcause)
+	if (data && atof((char *)data)) {
+		chan->hangupcause = atof((char *)data);
+	} else if (!chan->hangupcause) {
 		chan->hangupcause = AST_CAUSE_NORMAL_CLEARING;
+	}
 	return -1;
 }
 
